"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.getAttachmentLabel = getAttachmentLabel;
exports.getAttachments = getAttachments;
const types_1 = require("../../common/types");
function getAttachmentLabel(attachment) {
    if ((0, types_1.isDocsAttachment)(attachment)) {
        return `${attachment.docs.length} docs from dashboard '${attachment.dashboardTitle}'`;
    }
    return 'Unknown attachment';
}
// async function processGraphModel(graphModel) {
//   const labelMap = graphModel.nodes.reduce((acc, val) => {
//     return { ...acc, [val.id]: val.label };
//   }, {});
//   const context = {
//     '@context': {
//       '@vocab': 'http://example.org/'
//     },
//     '@graph': {
//       '@nodes': [],
//       '@edges': []
//     }
//   }
//   const vals = await Promise.all(graphModel.nodes.map(async (node) => {
//     let mainFields = []
//     if (node.entityId.length > 0 && !node.id.includes('VIRTUAL_ENTITY')) {
//       const dme = await sirenapi.DataModelEntity.getDataModelEntityById(node.entityId);
//       const fields = await dme.getFields();
//       mainFields = fields.reduce((a, f) => {
//         if(f.mainField) {
//           a.push(f.name);
//         }
//         return a || [];
//       }, []);
//       const { id, indexPattern, label, payload } = node;
//       const bdy = Object.entries(payload).reduce((acc, [k,v]) => {
//         if (mainFields.includes(k)) {
//           return { ...acc, [k]: v };
//         } else {
//           return acc
//         }
//       }, {});
//       return {
//         id,
//         indexPattern,
//         label,
//         body: bdy || payload
//       }
//     }
//   }));
//   context['@graph']['@nodes'] = vals.filter(v => v !== undefined)
//   context['@graph']['@edges'] = graphModel.relations.map((rel) => {
//     const { in: source, out: target, label } = rel;
//     return {
//       label: `${labelMap[target]} ${label} ${labelMap[source]} `,
//       target,
//       source
//     };
//   });
//   return JSON.stringify(context, null, 4);;
// }
async function processGraphModel(graphModel) {
    // todo: add relationships as well (see commented out function above lifted from report generator script)
    //return JSON.stringify(graphModel.nodes, null, 4);
    return graphModel.nodes.map(item => {
        return {
            graph_item_id: item.id,
            payload: item.payload
        };
    });
}
async function getAttachments(attachmentOptions) {
    const attachments = [];
    // auto attach if graph - also need to remove previous attachments from prior messages (bug??)
    // @ts-ignore
    const visParent = await sirenapi.Visualization.getCurrentVisualizer();
    const vis = await visParent?.getCurrentGraph();
    if (attachmentOptions.docsOnDashboard || (vis && vis !== undefined)) {
        let dashFound = false;
        try {
            // @ts-ignore
            const dashboard = await sirenapi.Dashboard.getCurrentDashboard();
            attachments.push({
                dashboardId: dashboard.getId(),
                dashboardTitle: dashboard.getTitle(),
                docs: await getDocsOnDashboard(),
                fromGraph: false
            });
            dashFound = true;
        }
        catch (e) {
            console.warn('warning:', e);
        }
        if (!dashFound) {
            attachments.push({
                dashboardId: visParent.id,
                dashboardTitle: visParent.title,
                docs: await processGraphModel(vis),
                fromGraph: true
            });
        }
    }
    return attachments;
}
async function getDocsOnDashboard() {
    // @ts-ignore
    const dashboard = await sirenapi.Dashboard.getCurrentDashboard();
    const searchSource = await dashboard.getSearchSource();
    return (await searchSource.fetch()).hits.hits;
}
