"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || (function () {
    var ownKeys = function(o) {
        ownKeys = Object.getOwnPropertyNames || function (o) {
            var ar = [];
            for (var k in o) if (Object.prototype.hasOwnProperty.call(o, k)) ar[ar.length] = k;
            return ar;
        };
        return ownKeys(o);
    };
    return function (mod) {
        if (mod && mod.__esModule) return mod;
        var result = {};
        if (mod != null) for (var k = ownKeys(mod), i = 0; i < k.length; i++) if (k[i] !== "default") __createBinding(result, mod, k[i]);
        __setModuleDefault(result, mod);
        return result;
    };
})();
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.MessageHistory = MessageHistory;
const moment_1 = __importDefault(require("moment"));
const react_1 = __importStar(require("react"));
const eui_1 = require("@elastic/eui");
const types_1 = require("../../common/types");
const attachments_1 = require("../lib/attachments");
const save_as_insight_modal_1 = require("./save_as_insight_modal");
function MessageHistory({ messages }) {
    const [messageAsInsight, setMessageAsInsight] = (0, react_1.useState)();
    const ref = (0, react_1.useRef)(null);
    (0, react_1.useEffect)(() => {
        ref.current?.scrollTo(0, Number.MAX_SAFE_INTEGER);
    }, [messages]);
    return (react_1.default.createElement(eui_1.EuiPanel, { paddingSize: "none" },
        react_1.default.createElement("div", { ref: ref, style: { minHeight: '400px', overflow: 'auto', maxHeight: 'calc(100vh - 200px)', margin: '8px' } },
            react_1.default.createElement(eui_1.EuiCommentList, { comments: messages.map(message => messageToComment(message, setMessageAsInsight)) })),
        react_1.default.createElement(save_as_insight_modal_1.SaveAsInsightModal, { message: messageAsInsight, messages: messages, onClose: () => setMessageAsInsight(undefined) })));
}
function messageToComment(message, onSaveAsInsightClick) {
    return {
        username: message.user || '',
        type: 'regular',
        timestamp: (0, moment_1.default)(message.timestamp).format('HH:mm:ss'),
        actions: message.user === types_1.User.Bot && (react_1.default.createElement(eui_1.EuiButtonIcon, { title: "Save as insight", color: "subdued", iconType: "save", onClick: () => onSaveAsInsightClick(message) })),
        timelineIcon: getTimelineIcon(message.user),
        children: react_1.default.createElement(MessageContent, { message: message })
    };
}
function MessageContent({ message }) {
    return (react_1.default.createElement("div", { style: { display: 'flex', flexDirection: 'column', gap: '8px' } },
        react_1.default.createElement("div", { dangerouslySetInnerHTML: { __html: message.content } }),
        message.attachments && (react_1.default.createElement("div", { style: { display: 'flex', gap: '4px' } }, message.attachments.map((attachment, i) => (react_1.default.createElement(eui_1.EuiBadge, { key: i, color: "success" }, (0, attachments_1.getAttachmentLabel)(attachment))))))));
}
function getTimelineIcon(user) {
    if (user === types_1.User.You) {
        return react_1.default.createElement(eui_1.EuiAvatar, { size: "l", name: "", color: "#6dccb1", iconType: "user", style: { display: 'flex' } });
    }
    else {
        return react_1.default.createElement(eui_1.EuiAvatar, { size: "l", name: "", color: "#79aad9", iconType: "compute", style: { display: 'flex' } });
    }
}
